<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
        "mybatis-3-mapper.dtd">
<mapper namespace="com.mortals.xhx.module.dept.dao.ibatis.DeptDaoImpl">

    <!-- 字段和属性映射 -->
    <resultMap type="DeptEntity" id="DeptEntity-Map">
        <id  property="id" column="id" />
        <result property="parentId" column="parentId" />
        <result property="ancestors" column="ancestors" />
        <result property="deptName" column="deptName" />
        <result property="deptCode" column="deptCode" />
        <result property="deptStatus" column="deptStatus" />
        <result property="orderNum" column="orderNum" />
        <result property="personNum" column="personNum" />
        <result property="workId" column="workId" />
        <result property="workName" column="workName" />
        <result property="remark" column="remark" />
        <result property="createUserId" column="createUserId" />
        <result property="createTime" column="createTime" />
        <result property="updateUserId" column="updateUserId" />
        <result property="updateTime" column="updateTime" />
        <result property="score" column="score" />

    </resultMap>


    <!-- 表所有列 -->
    <sql id="_columns">
        <trim suffixOverrides="," suffix="">
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('id') or colPickMode == 1 and data.containsKey('id')))">
                a.id,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('parentId') or colPickMode == 1 and data.containsKey('parentId')))">
                a.parentId,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('ancestors') or colPickMode == 1 and data.containsKey('ancestors')))">
                a.ancestors,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('deptName') or colPickMode == 1 and data.containsKey('deptName')))">
                a.deptName,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('deptCode') or colPickMode == 1 and data.containsKey('deptCode')))">
                a.deptCode,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('deptStatus') or colPickMode == 1 and data.containsKey('deptStatus')))">
                a.deptStatus,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('orderNum') or colPickMode == 1 and data.containsKey('orderNum')))">
                a.orderNum,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('personNum') or colPickMode == 1 and data.containsKey('personNum')))">
                a.personNum,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('workId') or colPickMode == 1 and data.containsKey('workId')))">
                a.workId,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('workName') or colPickMode == 1 and data.containsKey('workName')))">
                a.workName,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('remark') or colPickMode == 1 and data.containsKey('remark')))">
                a.remark,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createUserId') or colPickMode == 1 and data.containsKey('createUserId')))">
                a.createUserId,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createTime') or colPickMode == 1 and data.containsKey('createTime')))">
                a.createTime,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateUserId') or colPickMode == 1 and data.containsKey('updateUserId')))">
                a.updateUserId,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateTime') or colPickMode == 1 and data.containsKey('updateTime')))">
                a.updateTime,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('score') or colPickMode == 1 and data.containsKey('score')))">
                a.score,
            </if>
        </trim>
    </sql>
    <!-- 新增 区分主键自增加还是业务插入 -->
    <insert id="insert" parameterType="DeptEntity"  useGeneratedKeys="true" keyProperty="id">
        insert into mortals_xhx_dept
        (parentId,ancestors,deptName,deptCode,deptStatus,orderNum,personNum,workId,workName,remark,createUserId,createTime,updateUserId,updateTime,score)
        VALUES
        (#{parentId},#{ancestors},#{deptName},#{deptCode},#{deptStatus},#{orderNum},#{personNum},#{workId},#{workName},#{remark},#{createUserId},#{createTime},#{updateUserId},#{updateTime},#{score})
    </insert>

    <!-- 批量新增 -->
    <insert id="insertBatch" parameterType="paramDto">
        insert into mortals_xhx_dept
        (parentId,ancestors,deptName,deptCode,deptStatus,orderNum,personNum,workId,workName,remark,createUserId,createTime,updateUserId,updateTime,score)
        VALUES
        <foreach collection="data.dataList" item="item" index="index" separator="," >
            (#{item.parentId},#{item.ancestors},#{item.deptName},#{item.deptCode},#{item.deptStatus},#{item.orderNum},#{item.personNum},#{item.workId},#{item.workName},#{item.remark},#{item.createUserId},#{item.createTime},#{item.updateUserId},#{item.updateTime},#{item.score})
        </foreach>
    </insert>


    <!-- 根据ParamDto更新 -->
    <update id="update" parameterType="paramDto">
        update mortals_xhx_dept as a
        set
        <trim suffixOverrides="," suffix="">
            <if test="(colPickMode==0 and data.containsKey('parentId')) or (colPickMode==1 and !data.containsKey('parentId'))">
                a.parentId=#{data.parentId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('parentIdIncrement')) or (colPickMode==1 and !data.containsKey('parentIdIncrement'))">
                a.parentId=ifnull(a.parentId,0) + #{data.parentIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('ancestors')) or (colPickMode==1 and !data.containsKey('ancestors'))">
                a.ancestors=#{data.ancestors},
            </if>
            <if test="(colPickMode==0 and data.containsKey('deptName')) or (colPickMode==1 and !data.containsKey('deptName'))">
                a.deptName=#{data.deptName},
            </if>
            <if test="(colPickMode==0 and data.containsKey('deptCode')) or (colPickMode==1 and !data.containsKey('deptCode'))">
                a.deptCode=#{data.deptCode},
            </if>
            <if test="(colPickMode==0 and data.containsKey('deptStatus')) or (colPickMode==1 and !data.containsKey('deptStatus'))">
                a.deptStatus=#{data.deptStatus},
            </if>
            <if test="(colPickMode==0 and data.containsKey('deptStatusIncrement')) or (colPickMode==1 and !data.containsKey('deptStatusIncrement'))">
                a.deptStatus=ifnull(a.deptStatus,0) + #{data.deptStatusIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('orderNum')) or (colPickMode==1 and !data.containsKey('orderNum'))">
                a.orderNum=#{data.orderNum},
            </if>
            <if test="(colPickMode==0 and data.containsKey('orderNumIncrement')) or (colPickMode==1 and !data.containsKey('orderNumIncrement'))">
                a.orderNum=ifnull(a.orderNum,0) + #{data.orderNumIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('personNum')) or (colPickMode==1 and !data.containsKey('personNum'))">
                a.personNum=#{data.personNum},
            </if>
            <if test="(colPickMode==0 and data.containsKey('personNumIncrement')) or (colPickMode==1 and !data.containsKey('personNumIncrement'))">
                a.personNum=ifnull(a.personNum,0) + #{data.personNumIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('workId')) or (colPickMode==1 and !data.containsKey('workId'))">
                a.workId=#{data.workId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('workIdIncrement')) or (colPickMode==1 and !data.containsKey('workIdIncrement'))">
                a.workId=ifnull(a.workId,0) + #{data.workIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('workName')) or (colPickMode==1 and !data.containsKey('workName'))">
                a.workName=#{data.workName},
            </if>
            <if test="(colPickMode==0 and data.containsKey('remark')) or (colPickMode==1 and !data.containsKey('remark'))">
                a.remark=#{data.remark},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createUserId')) or (colPickMode==1 and !data.containsKey('createUserId'))">
                a.createUserId=#{data.createUserId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createUserIdIncrement')) or (colPickMode==1 and !data.containsKey('createUserIdIncrement'))">
                a.createUserId=ifnull(a.createUserId,0) + #{data.createUserIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createTime')) or (colPickMode==1 and !data.containsKey('createTime'))">
                a.createTime=#{data.createTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateUserId')) or (colPickMode==1 and !data.containsKey('updateUserId'))">
                a.updateUserId=#{data.updateUserId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateUserIdIncrement')) or (colPickMode==1 and !data.containsKey('updateUserIdIncrement'))">
                a.updateUserId=ifnull(a.updateUserId,0) + #{data.updateUserIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateTime')) or (colPickMode==1 and !data.containsKey('updateTime'))">
                a.updateTime=#{data.updateTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('score')) or (colPickMode==1 and !data.containsKey('score'))">
                a.score=#{data.score},
            </if>
            <if test="(colPickMode==0 and data.containsKey('scoreIncrement')) or (colPickMode==1 and !data.containsKey('scoreIncrement'))">
                a.score=ifnull(a.score,0) + #{data.scoreIncrement},
            </if>
        </trim>
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </update>
    <!-- 批量更新 -->
    <update id="updateBatch" parameterType="paramDto">
        update mortals_xhx_dept as a
        <trim prefix="set" suffixOverrides=",">
            <trim prefix="parentId=(case" suffix="ELSE parentId end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('parentId')) or (colPickMode==1 and !item.containsKey('parentId'))">
                            when a.id=#{item.id} then #{item.parentId}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('parentIdIncrement')) or (colPickMode==1 and !item.containsKey('parentIdIncrement'))">
                            when a.id=#{item.id} then ifnull(a.parentId,0) + #{item.parentIdIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="ancestors=(case" suffix="ELSE ancestors end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('ancestors')) or (colPickMode==1 and !item.containsKey('ancestors'))">
                        when a.id=#{item.id} then #{item.ancestors}
                    </if>
                </foreach>
            </trim>
            <trim prefix="deptName=(case" suffix="ELSE deptName end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('deptName')) or (colPickMode==1 and !item.containsKey('deptName'))">
                        when a.id=#{item.id} then #{item.deptName}
                    </if>
                </foreach>
            </trim>
            <trim prefix="deptCode=(case" suffix="ELSE deptCode end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('deptCode')) or (colPickMode==1 and !item.containsKey('deptCode'))">
                        when a.id=#{item.id} then #{item.deptCode}
                    </if>
                </foreach>
            </trim>
            <trim prefix="deptStatus=(case" suffix="ELSE deptStatus end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('deptStatus')) or (colPickMode==1 and !item.containsKey('deptStatus'))">
                            when a.id=#{item.id} then #{item.deptStatus}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('deptStatusIncrement')) or (colPickMode==1 and !item.containsKey('deptStatusIncrement'))">
                            when a.id=#{item.id} then ifnull(a.deptStatus,0) + #{item.deptStatusIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="orderNum=(case" suffix="ELSE orderNum end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('orderNum')) or (colPickMode==1 and !item.containsKey('orderNum'))">
                            when a.id=#{item.id} then #{item.orderNum}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('orderNumIncrement')) or (colPickMode==1 and !item.containsKey('orderNumIncrement'))">
                            when a.id=#{item.id} then ifnull(a.orderNum,0) + #{item.orderNumIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="personNum=(case" suffix="ELSE personNum end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('personNum')) or (colPickMode==1 and !item.containsKey('personNum'))">
                            when a.id=#{item.id} then #{item.personNum}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('personNumIncrement')) or (colPickMode==1 and !item.containsKey('personNumIncrement'))">
                            when a.id=#{item.id} then ifnull(a.personNum,0) + #{item.personNumIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="workId=(case" suffix="ELSE workId end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('workId')) or (colPickMode==1 and !item.containsKey('workId'))">
                            when a.id=#{item.id} then #{item.workId}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('workIdIncrement')) or (colPickMode==1 and !item.containsKey('workIdIncrement'))">
                            when a.id=#{item.id} then ifnull(a.workId,0) + #{item.workIdIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="workName=(case" suffix="ELSE workName end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('workName')) or (colPickMode==1 and !item.containsKey('workName'))">
                        when a.id=#{item.id} then #{item.workName}
                    </if>
                </foreach>
            </trim>
            <trim prefix="remark=(case" suffix="ELSE remark end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('remark')) or (colPickMode==1 and !item.containsKey('remark'))">
                        when a.id=#{item.id} then #{item.remark}
                    </if>
                </foreach>
            </trim>
            <trim prefix="createUserId=(case" suffix="ELSE createUserId end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('createUserId')) or (colPickMode==1 and !item.containsKey('createUserId'))">
                            when a.id=#{item.id} then #{item.createUserId}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('createUserIdIncrement')) or (colPickMode==1 and !item.containsKey('createUserIdIncrement'))">
                            when a.id=#{item.id} then ifnull(a.createUserId,0) + #{item.createUserIdIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="createTime=(case" suffix="ELSE createTime end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('createTime')) or (colPickMode==1 and !item.containsKey('createTime'))">
                        when a.id=#{item.id} then #{item.createTime}
                    </if>
                </foreach>
            </trim>
            <trim prefix="updateUserId=(case" suffix="ELSE updateUserId end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('updateUserId')) or (colPickMode==1 and !item.containsKey('updateUserId'))">
                            when a.id=#{item.id} then #{item.updateUserId}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('updateUserIdIncrement')) or (colPickMode==1 and !item.containsKey('updateUserIdIncrement'))">
                            when a.id=#{item.id} then ifnull(a.updateUserId,0) + #{item.updateUserIdIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="updateTime=(case" suffix="ELSE updateTime end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('updateTime')) or (colPickMode==1 and !item.containsKey('updateTime'))">
                        when a.id=#{item.id} then #{item.updateTime}
                    </if>
                </foreach>
            </trim>
            <trim prefix="score=(case" suffix="ELSE score end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('score')) or (colPickMode==1 and !item.containsKey('score'))">
                            when a.id=#{item.id} then #{item.score}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('scoreIncrement')) or (colPickMode==1 and !item.containsKey('scoreIncrement'))">
                            when a.id=#{item.id} then ifnull(a.score,0) + #{item.scoreIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
        </trim>
        where id in
        <foreach collection="data.dataList" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </update>
    <!-- 根据主健查询 -->
    <select id="getByKey" parameterType="paramDto" resultMap="DeptEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_dept as a
        where a.id=#{condition.id}
    </select>
    <!-- 根据主健删除 -->
    <delete id="deleteByKey" parameterType="paramDto">
        delete a.* from mortals_xhx_dept as a where a.id=#{condition.id}
    </delete>
    <!-- 根据主健删除一批，针对单一主健有效 -->
    <delete id="deleteByKeys">
        delete from mortals_xhx_dept where id in
        <foreach collection="array" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>
    <!-- 根据主健列表删除一批，针对单一主健有效 -->
    <delete id="deleteByKeyList">
        delete from mortals_xhx_dept where id in
        <foreach collection="list" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>

    <!-- 根据对象列表删除一批，针对单一主健有效 -->
    <delete id="deleteByEntityList">
        delete from mortals_xhx_dept where id in
        <foreach collection="list" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </delete>
    <!-- 根据paramDto删除一批 -->
    <delete id="deleteByMap" parameterType="paramDto">
        delete a.* from mortals_xhx_dept as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </delete>
    <!-- 获取列表 -->
    <select id="getList" parameterType="paramDto" resultMap="DeptEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_dept as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
        <include refid="_orderCols_"/>
    </select>


    <!-- 获取子节点 -->
    <select id="selectChildrenDeptById" parameterType="String" resultMap="DeptEntity-Map">
        select * from mortals_xhx_dept as a where find_in_set(#{deptId}, ancestors)
    </select>

    <!-- 获取 -->
    <select id="getListCount" parameterType="paramDto" resultType="int">
        select count(1)
        from mortals_xhx_dept as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </select>
    <!-- 条件映射 -->
    <sql id="_condition_">
        <if test="condition != null and !condition.isEmpty()">
            <!-- 条件映射-普通条件 -->
            <include refid="_condition_param_">
                <property name="_conditionParam_" value="condition"/>
                <property name="_conditionType_" value="and"/>
            </include>
            <!-- 条件映射-集合之间使用AND，集合中元素使用OR-(list[0].1 or list[0].2) and (list[1].3 or list[1].4) -->
            <if test="condition.containsKey('andConditionList') and !condition.andConditionList.isEmpty()">
                and
                <foreach collection="condition.andConditionList" open="(" close=")" index="index" item="andCondition" separator=" and ">
                    <trim prefixOverrides="or" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="andCondition"/>
                            <property name="_conditionType_" value="or"/>
                        </include>
                    </trim>
                </foreach>
            </if>
            <!-- 条件映射-集合之间使用OR，集合中元素使用AND-(list[0].1 and list[0].2) or (list[1].3 and list[1].4) -->
            <if test="condition.containsKey('orConditionList') and !condition.orConditionList.isEmpty()">
                and
                <foreach collection="condition.orConditionList" open="(" close=")" index="index" item="orCondition" separator=" or ">
                    <trim prefixOverrides="and" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="orCondition"/>
                            <property name="_conditionType_" value="and"/>
                        </include>
                    </trim>
                </foreach>
            </if>
        </if>
    </sql>
    <!-- 条件映射-代参数 -->
    <sql id="_condition_param_">
        <bind name="conditionParamRef" value="${_conditionParam_}"/>
        <if test="conditionParamRef.containsKey('id')">
            <if test="conditionParamRef.id != null">
                ${_conditionType_} a.id=#{${_conditionParam_}.id}
            </if>
        </if>
        <if test="conditionParamRef.containsKey('id')">
            <if test="conditionParamRef.id != null ">
                ${_conditionType_} a.id = #{${_conditionParam_}.id}
            </if>
            <if test="conditionParamRef.id == null">
                ${_conditionType_} a.id is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('idList') and conditionParamRef.idList.size() > 0">
            ${_conditionType_} a.id in
            <foreach collection="conditionParamRef.idList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('idNotList') and conditionParamRef.idNotList.size() > 0">
            ${_conditionType_} a.id not in
            <foreach collection="conditionParamRef.idNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('idStart') and conditionParamRef.idStart != null">
            ${_conditionType_} a.id <![CDATA[ >= ]]> #{${_conditionParam_}.idStart}
        </if>
        <if test="conditionParamRef.containsKey('idEnd') and conditionParamRef.idEnd != null">
            ${_conditionType_} a.id <![CDATA[ <= ]]> #{${_conditionParam_}.idEnd}
        </if>

        <if test="conditionParamRef.containsKey('parentId')">
            <if test="conditionParamRef.parentId != null ">
                ${_conditionType_} a.parentId = #{${_conditionParam_}.parentId}
            </if>
            <if test="conditionParamRef.parentId == null">
                ${_conditionType_} a.parentId is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('parentIdList') and conditionParamRef.parentIdList.size() > 0">
            ${_conditionType_} a.parentId in
            <foreach collection="conditionParamRef.parentIdList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('parentIdNotList') and conditionParamRef.parentIdNotList.size() > 0">
            ${_conditionType_} a.parentId not in
            <foreach collection="conditionParamRef.parentIdNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('parentIdStart') and conditionParamRef.parentIdStart != null">
            ${_conditionType_} a.parentId <![CDATA[ >= ]]> #{${_conditionParam_}.parentIdStart}
        </if>
        <if test="conditionParamRef.containsKey('parentIdEnd') and conditionParamRef.parentIdEnd != null">
            ${_conditionType_} a.parentId <![CDATA[ <= ]]> #{${_conditionParam_}.parentIdEnd}
        </if>


        <if test="conditionParamRef.containsKey('ancestors')">
            <if test="conditionParamRef.ancestors != null and conditionParamRef.ancestors != ''">
                ${_conditionType_} a.ancestors like #{${_conditionParam_}.ancestors}
            </if>
            <if test="conditionParamRef.ancestors == null">
                ${_conditionType_} a.ancestors is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('ancestorsList') and conditionParamRef.ancestorsList.size() > 0">
            ${_conditionType_} a.ancestors in
            <foreach collection="conditionParamRef.ancestorsList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('ancestorsNotList') and conditionParamRef.ancestorsNotList.size() > 0">
            ${_conditionType_} a.ancestors not in
            <foreach collection="conditionParamRef.ancestorsNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>

        <if test="conditionParamRef.containsKey('deptName')">
            <if test="conditionParamRef.deptName != null and conditionParamRef.deptName != ''">
                ${_conditionType_} a.deptName like #{${_conditionParam_}.deptName}
            </if>
            <if test="conditionParamRef.deptName == null">
                ${_conditionType_} a.deptName is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('deptNameList') and conditionParamRef.deptNameList.size() > 0">
            ${_conditionType_} a.deptName in
            <foreach collection="conditionParamRef.deptNameList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('deptNameNotList') and conditionParamRef.deptNameNotList.size() > 0">
            ${_conditionType_} a.deptName not in
            <foreach collection="conditionParamRef.deptNameNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>

        <if test="conditionParamRef.containsKey('deptCode')">
            <if test="conditionParamRef.deptCode != null and conditionParamRef.deptCode != ''">
                ${_conditionType_} a.deptCode like #{${_conditionParam_}.deptCode}
            </if>
            <if test="conditionParamRef.deptCode == null">
                ${_conditionType_} a.deptCode is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('deptCodeList') and conditionParamRef.deptCodeList.size() > 0">
            ${_conditionType_} a.deptCode in
            <foreach collection="conditionParamRef.deptCodeList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('deptCodeNotList') and conditionParamRef.deptCodeNotList.size() > 0">
            ${_conditionType_} a.deptCode not in
            <foreach collection="conditionParamRef.deptCodeNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('deptStatus')">
            <if test="conditionParamRef.deptStatus != null ">
                ${_conditionType_} a.deptStatus = #{${_conditionParam_}.deptStatus}
            </if>
            <if test="conditionParamRef.deptStatus == null">
                ${_conditionType_} a.deptStatus is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('deptStatusList') and conditionParamRef.deptStatusList.size() > 0">
            ${_conditionType_} a.deptStatus in
            <foreach collection="conditionParamRef.deptStatusList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('deptStatusNotList') and conditionParamRef.deptStatusNotList.size() > 0">
            ${_conditionType_} a.deptStatus not in
            <foreach collection="conditionParamRef.deptStatusNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('deptStatusStart') and conditionParamRef.deptStatusStart != null">
            ${_conditionType_} a.deptStatus <![CDATA[ >= ]]> #{${_conditionParam_}.deptStatusStart}
        </if>
        <if test="conditionParamRef.containsKey('deptStatusEnd') and conditionParamRef.deptStatusEnd != null">
            ${_conditionType_} a.deptStatus <![CDATA[ <= ]]> #{${_conditionParam_}.deptStatusEnd}
        </if>

        <if test="conditionParamRef.containsKey('orderNum')">
            <if test="conditionParamRef.orderNum != null ">
                ${_conditionType_} a.orderNum = #{${_conditionParam_}.orderNum}
            </if>
            <if test="conditionParamRef.orderNum == null">
                ${_conditionType_} a.orderNum is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('orderNumList') and conditionParamRef.orderNumList.size() > 0">
            ${_conditionType_} a.orderNum in
            <foreach collection="conditionParamRef.orderNumList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('orderNumNotList') and conditionParamRef.orderNumNotList.size() > 0">
            ${_conditionType_} a.orderNum not in
            <foreach collection="conditionParamRef.orderNumNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('orderNumStart') and conditionParamRef.orderNumStart != null">
            ${_conditionType_} a.orderNum <![CDATA[ >= ]]> #{${_conditionParam_}.orderNumStart}
        </if>
        <if test="conditionParamRef.containsKey('orderNumEnd') and conditionParamRef.orderNumEnd != null">
            ${_conditionType_} a.orderNum <![CDATA[ <= ]]> #{${_conditionParam_}.orderNumEnd}
        </if>

        <if test="conditionParamRef.containsKey('personNum')">
            <if test="conditionParamRef.personNum != null ">
                ${_conditionType_} a.personNum = #{${_conditionParam_}.personNum}
            </if>
            <if test="conditionParamRef.personNum == null">
                ${_conditionType_} a.personNum is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('personNumList') and conditionParamRef.personNumList.size() > 0">
            ${_conditionType_} a.personNum in
            <foreach collection="conditionParamRef.personNumList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('personNumNotList') and conditionParamRef.personNumNotList.size() > 0">
            ${_conditionType_} a.personNum not in
            <foreach collection="conditionParamRef.personNumNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('personNumStart') and conditionParamRef.personNumStart != null">
            ${_conditionType_} a.personNum <![CDATA[ >= ]]> #{${_conditionParam_}.personNumStart}
        </if>
        <if test="conditionParamRef.containsKey('personNumEnd') and conditionParamRef.personNumEnd != null">
            ${_conditionType_} a.personNum <![CDATA[ <= ]]> #{${_conditionParam_}.personNumEnd}
        </if>

        <if test="conditionParamRef.containsKey('workId')">
            <if test="conditionParamRef.workId != null ">
                ${_conditionType_} a.workId = #{${_conditionParam_}.workId}
            </if>
            <if test="conditionParamRef.workId == null">
                ${_conditionType_} a.workId is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('workIdList') and conditionParamRef.workIdList.size() > 0">
            ${_conditionType_} a.workId in
            <foreach collection="conditionParamRef.workIdList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('workIdNotList') and conditionParamRef.workIdNotList.size() > 0">
            ${_conditionType_} a.workId not in
            <foreach collection="conditionParamRef.workIdNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('workIdStart') and conditionParamRef.workIdStart != null">
            ${_conditionType_} a.workId <![CDATA[ >= ]]> #{${_conditionParam_}.workIdStart}
        </if>
        <if test="conditionParamRef.containsKey('workIdEnd') and conditionParamRef.workIdEnd != null">
            ${_conditionType_} a.workId <![CDATA[ <= ]]> #{${_conditionParam_}.workIdEnd}
        </if>


        <if test="conditionParamRef.containsKey('workName')">
            <if test="conditionParamRef.workName != null and conditionParamRef.workName != ''">
                ${_conditionType_} a.workName like #{${_conditionParam_}.workName}
            </if>
            <if test="conditionParamRef.workName == null">
                ${_conditionType_} a.workName is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('workNameList') and conditionParamRef.workNameList.size() > 0">
            ${_conditionType_} a.workName in
            <foreach collection="conditionParamRef.workNameList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('workNameNotList') and conditionParamRef.workNameNotList.size() > 0">
            ${_conditionType_} a.workName not in
            <foreach collection="conditionParamRef.workNameNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>

        <if test="conditionParamRef.containsKey('remark')">
            <if test="conditionParamRef.remark != null and conditionParamRef.remark != ''">
                ${_conditionType_} a.remark like #{${_conditionParam_}.remark}
            </if>
            <if test="conditionParamRef.remark == null">
                ${_conditionType_} a.remark is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('remarkList') and conditionParamRef.remarkList.size() > 0">
            ${_conditionType_} a.remark in
            <foreach collection="conditionParamRef.remarkList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('remarkNotList') and conditionParamRef.remarkNotList.size() > 0">
            ${_conditionType_} a.remark not in
            <foreach collection="conditionParamRef.remarkNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('createUserId')">
            <if test="conditionParamRef.createUserId != null ">
                ${_conditionType_} a.createUserId = #{${_conditionParam_}.createUserId}
            </if>
            <if test="conditionParamRef.createUserId == null">
                ${_conditionType_} a.createUserId is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('createUserIdList') and conditionParamRef.createUserIdList.size() > 0">
            ${_conditionType_} a.createUserId in
            <foreach collection="conditionParamRef.createUserIdList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('createUserIdNotList') and conditionParamRef.createUserIdNotList.size() > 0">
            ${_conditionType_} a.createUserId not in
            <foreach collection="conditionParamRef.createUserIdNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('createUserIdStart') and conditionParamRef.createUserIdStart != null">
            ${_conditionType_} a.createUserId <![CDATA[ >= ]]> #{${_conditionParam_}.createUserIdStart}
        </if>
        <if test="conditionParamRef.containsKey('createUserIdEnd') and conditionParamRef.createUserIdEnd != null">
            ${_conditionType_} a.createUserId <![CDATA[ <= ]]> #{${_conditionParam_}.createUserIdEnd}
        </if>


        <if test="conditionParamRef.containsKey('createTime')">
            <if test="conditionParamRef.createTime != null ">
                ${_conditionType_} a.createTime = #{${_conditionParam_}.createTime}
            </if>
            <if test="conditionParamRef.createTime == null">
                ${_conditionType_} a.createTime is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('createTimeStart') and conditionParamRef.createTimeStart != null and conditionParamRef.createTimeStart!=''">
            ${_conditionType_} a.createTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
        </if>
        <if test="conditionParamRef.containsKey('createTimeEnd') and conditionParamRef.createTimeEnd != null and conditionParamRef.createTimeEnd!=''">
            ${_conditionType_} a.createTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
        </if>
        <if test="conditionParamRef.containsKey('updateUserId')">
            <if test="conditionParamRef.updateUserId != null ">
                ${_conditionType_} a.updateUserId = #{${_conditionParam_}.updateUserId}
            </if>
            <if test="conditionParamRef.updateUserId == null">
                ${_conditionType_} a.updateUserId is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('updateUserIdList') and conditionParamRef.updateUserIdList.size() > 0">
            ${_conditionType_} a.updateUserId in
            <foreach collection="conditionParamRef.updateUserIdList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('updateUserIdNotList') and conditionParamRef.updateUserIdNotList.size() > 0">
            ${_conditionType_} a.updateUserId not in
            <foreach collection="conditionParamRef.updateUserIdNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('updateUserIdStart') and conditionParamRef.updateUserIdStart != null">
            ${_conditionType_} a.updateUserId <![CDATA[ >= ]]> #{${_conditionParam_}.updateUserIdStart}
        </if>
        <if test="conditionParamRef.containsKey('updateUserIdEnd') and conditionParamRef.updateUserIdEnd != null">
            ${_conditionType_} a.updateUserId <![CDATA[ <= ]]> #{${_conditionParam_}.updateUserIdEnd}
        </if>


        <if test="conditionParamRef.containsKey('updateTime')">
            <if test="conditionParamRef.updateTime != null ">
                ${_conditionType_} a.updateTime = #{${_conditionParam_}.updateTime}
            </if>
            <if test="conditionParamRef.updateTime == null">
                ${_conditionType_} a.updateTime is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('updateTimeStart') and conditionParamRef.updateTimeStart != null and conditionParamRef.updateTimeStart!=''">
            ${_conditionType_} a.updateTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
        </if>
        <if test="conditionParamRef.containsKey('updateTimeEnd') and conditionParamRef.updateTimeEnd != null and conditionParamRef.updateTimeEnd!=''">
            ${_conditionType_} a.updateTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
        </if>
        <if test="conditionParamRef.containsKey('score')">
            <if test="conditionParamRef.score != null ">
                ${_conditionType_} a.score = #{${_conditionParam_}.score}
            </if>
            <if test="conditionParamRef.score == null">
                ${_conditionType_} a.score is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('scoreList') and conditionParamRef.scoreList.size() > 0">
            ${_conditionType_} a.score in
            <foreach collection="conditionParamRef.scoreList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('scoreNotList') and conditionParamRef.scoreNotList.size() > 0">
            ${_conditionType_} a.score not in
            <foreach collection="conditionParamRef.scoreNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('scoreStart') and conditionParamRef.scoreStart != null">
            ${_conditionType_} a.score <![CDATA[ >= ]]> #{${_conditionParam_}.scoreStart}
        </if>
        <if test="conditionParamRef.containsKey('scoreEnd') and conditionParamRef.scoreEnd != null">
            ${_conditionType_} a.score <![CDATA[ <= ]]> #{${_conditionParam_}.scoreEnd}
        </if>

    </sql>
    <sql id="_orderCols_">
        <if test="orderColList != null and !orderColList.isEmpty()">
            order by
            <trim suffixOverrides=","  suffix="">
                <foreach collection="orderColList" open="" close="" index="index" item="item" separator=",">
                    ${item.colName} ${item.sortKind}
                </foreach>
            </trim>
        </if>
        <if test="(orderColList == null or orderColList.isEmpty()) and orderCol != null and !orderCol.isEmpty()">
            order by
            <trim suffixOverrides=","  suffix="">
                <if test="orderCol.containsKey('id')">
                    a.id
                    <if test='orderCol.id != null and "DESC".equalsIgnoreCase(orderCol.id)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('parentId')">
                    a.parentId
                    <if test='orderCol.parentId != null and "DESC".equalsIgnoreCase(orderCol.parentId)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('ancestors')">
                    a.ancestors
                    <if test='orderCol.ancestors != null and "DESC".equalsIgnoreCase(orderCol.ancestors)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('deptName')">
                    a.deptName
                    <if test='orderCol.deptName != null and "DESC".equalsIgnoreCase(orderCol.deptName)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('deptCode')">
                    a.deptCode
                    <if test='orderCol.deptCode != null and "DESC".equalsIgnoreCase(orderCol.deptCode)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('deptStatus')">
                    a.deptStatus
                    <if test='orderCol.deptStatus != null and "DESC".equalsIgnoreCase(orderCol.deptStatus)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('orderNum')">
                    a.orderNum
                    <if test='orderCol.orderNum != null and "DESC".equalsIgnoreCase(orderCol.orderNum)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('personNum')">
                    a.personNum
                    <if test='orderCol.personNum != null and "DESC".equalsIgnoreCase(orderCol.personNum)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('workId')">
                    a.workId
                    <if test='orderCol.workId != null and "DESC".equalsIgnoreCase(orderCol.workId)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('workName')">
                    a.workName
                    <if test='orderCol.workName != null and "DESC".equalsIgnoreCase(orderCol.workName)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('remark')">
                    a.remark
                    <if test='orderCol.remark != null and "DESC".equalsIgnoreCase(orderCol.remark)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('createUserId')">
                    a.createUserId
                    <if test='orderCol.createUserId != null and "DESC".equalsIgnoreCase(orderCol.createUserId)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('createTime')">
                    a.createTime
                    <if test='orderCol.createTime != null and "DESC".equalsIgnoreCase(orderCol.createTime)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('updateUserId')">
                    a.updateUserId
                    <if test='orderCol.updateUserId != null and "DESC".equalsIgnoreCase(orderCol.updateUserId)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('updateTime')">
                    a.updateTime
                    <if test='orderCol.updateTime != null and "DESC".equalsIgnoreCase(orderCol.updateTime)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('score')">
                    a.score
                    <if test='orderCol.score != null and "DESC".equalsIgnoreCase(orderCol.score)'>DESC</if>
                    ,
                </if>
            </trim>
        </if>
    </sql>
    <sql id="_group_by_">
        <if test="groupList != null and !groupList.isEmpty()">
            GROUP BY
            <trim suffixOverrides=","  suffix="">
                <foreach collection="groupList" open="" close="" index="index" item="item" separator=",">
                    ${item}
                </foreach>
            </trim>
        </if>
    </sql>
</mapper>